"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

var _index = _interopRequireDefault(require("../../Modules/index.js"));

var _FilterModule = _interopRequireDefault(require("../../Modules/FilterModule.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Table = _index.default.Table,
    Pagination = _index.default.Pagination,
    Form = _index.default.Form;
var Module = _modularityFront.default.Module; // NOT USED ANYWHERE YET

var Search =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(Search, _Modularity$Module);

  function Search(props) {
    var _this;

    _classCallCheck(this, Search);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Search).call(this, props));
    _this.state = {
      page: 1,
      data: [],
      totalPages: 1,
      showForm: false,
      model: {},
      mode: 0,
      formButton: "Add"
    };

    _this.service.onUpdate(function () {
      return _this.serviceUpdate(_this.state.page);
    });

    _this.serviceUpdate(_this.state.page);

    return _this;
  }

  _createClass(Search, [{
    key: "_rowDeleted",
    value: function _rowDeleted(row) {
      var _this2 = this;

      if (!row) return;
      var Service = this.service.value;
      if (Service.delete && row.id) Service.delete(row.id).then(function () {
        return _this2.serviceUpdate(_this2.state.page);
      });
    }
  }, {
    key: "handleClick",
    value: function handleClick() {
      console.log("added");
    }
  }, {
    key: "prepareForm",
    value: function prepareForm(headers) {
      var row = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var mod = {};
      console.log(headers);

      for (var i in headers) {
        if (!headers[i]) continue; //if(headers[i].fieldName === "id") continue;

        mod[headers[i].Name || headers[i].fieldName] = {
          type: "text",
          placeholder: i,
          columns: 6,
          value: row[i],
          filter: headers[i].filter
        };
      }

      return mod;
    }
  }, {
    key: "showAddForm",
    value: function showAddForm() {
      var headers = this.TableHeaders.value; // add Required !

      var mod = this.prepareForm(headers);
      this.setState({
        showForm: true,
        model: mod,
        mode: 0,
        formButton: 'Add'
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var page = this.state.page,
          totalPages = this.state.totalPages,
          data = this.state.data;

      var TableView = _react.default.createElement(_reactMaterialize.Row, {
        style: {
          display: 'flex'
        }
      }, _react.default.createElement(_reactMaterialize.Col, {
        s: 2,
        style: this.props.filterStyle,
        className: this.props.filterClassName
      }, _react.default.createElement(_FilterModule.default, {
        Inputs: this.FilterInput.value,
        Filters: function Filters(filters) {
          return _this3.setFilters(filters);
        }
      })), _react.default.createElement(_reactMaterialize.Col, {
        s: 10
      }, _react.default.createElement(Table, {
        TableHeaders: this.TableHeaders.value,
        TableData: data,
        TableClass: this.TableClass.value,
        LiveEdit: this.LiveEdit.value,
        EditedRow: function EditedRow(v) {
          return _this3.rowEdit(v);
        },
        onEdit: function onEdit(v) {
          return _this3._rowEdited(v);
        },
        onDelete: function onDelete(v) {
          return _this3._rowDeleted(v);
        }
      }), _react.default.createElement(_reactMaterialize.Row, null, _react.default.createElement(_reactMaterialize.Col, {
        offset: "s10"
      }, _react.default.createElement(_reactMaterialize.Button, {
        onClick: function onClick() {
          return _this3.showAddForm();
        }
      }, "Add"))), _react.default.createElement(Pagination, {
        selected: page,
        lastPage: totalPages,
        onPage: function onPage(v) {
          return _this3.pageChanged(v);
        }
      })));

      var FormView = _react.default.createElement(_reactMaterialize.Row, {
        key: Math.random()
      }, _react.default.createElement(_reactMaterialize.Col, {
        s: 12
      }, _react.default.createElement(Form, {
        FormInputs: this.state.model,
        button: this.state.formButton,
        formData: function formData(data) {
          return _this3.state.mode ? _this3.update(data) : _this3.add(data);
        }
      })));

      return [this.state.showForm ? FormView : TableView, _get(_getPrototypeOf(Search.prototype), "render", this).call(this)];
    }
  }]);

  return Search;
}(_modularityFront.default.Module);

Search.Inputs = {
  service: {
    type: Module.Types.Object,
    defaultValue: {}
  },
  perPage: {
    type: Module.Types.Number,
    defaultValue: 2
  },
  TableHeaders: {
    type: Module.Types.Object,
    defaultValue: {
      "Id": "id",
      "Name": "name",
      "Value": "price"
    }
  },
  TableClass: {
    type: Module.Types.Text,
    defaultValue: "striped centered"
  },
  LiveEdit: {
    type: Module.Types.Boolean,
    defaultValue: false
  },
  FilterInput: {
    type: Module.Types.Array,
    arrType: Module.Types.Object
  }
};
Search.Outputs = {
  onFilters: {}
};
Search.Category = "Nikatlas";
Search.EditPosition = "top-right";
var _default = Search;
exports.default = _default;