"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

var _index = _interopRequireDefault(require("../Modules/index.js"));

var _FilterModule = _interopRequireDefault(require("../Modules/FilterModule.js"));

require("./ListModule.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Table = _index.default.Table,
    Pagination = _index.default.Pagination,
    Form = _index.default.Form;
var Module = _modularityFront.default.Module;

var pTimeout = function pTimeout(time, item) {
  return new Promise(function (res, rej) {
    setTimeout(function () {
      return res(item);
    }, time);
  });
};

var ListModule =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(ListModule, _Modularity$Module);

  function ListModule(props) {
    var _this;

    _classCallCheck(this, ListModule);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ListModule).call(this, props));
    _this.state = {
      page: 1,
      data: [],
      totalPages: 1,
      showForm: false,
      model: {},
      mode: 0,
      formButton: "Add"
    };

    _this.service.onUpdate(function () {
      return _this.serviceUpdate(_this.state.page);
    });

    _this.serviceUpdate(_this.state.page);

    var route = _this.RoutingSystem.getRoute().url;

    if (route.endsWith("/add")) {
      pTimeout(1000).then(function () {
        return _this.showAddForm();
      });
    }

    console.log("ROUTE ", route);
    return _this;
  }

  _createClass(ListModule, [{
    key: "serviceUpdate",
    value: function serviceUpdate() {
      var _this2 = this;

      var page = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      var Service = this.service.value;
      if (!Service.count) return;
      var perPage = this.perPage.value;
      return Service.count().then(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 1),
            counter = _ref2[0].counter;

        var totalPages = parseInt(counter / perPage + 0.999);
        page = page <= totalPages ? page : totalPages;

        _this2.setState({
          totalPages: totalPages,
          page: page
        });

        return Service.getPage(page, perPage);
      }).then(function (data) {
        _this2.setState({
          data: data
        });
      }).catch(function (e) {
        return console.log(e);
      });
    }
  }, {
    key: "setFilters",
    value: function setFilters(filters) {
      this.onFilters.set(filters);
    }
  }, {
    key: "pageChanged",
    value: function pageChanged(v) {
      this.serviceUpdate(v);
    }
  }, {
    key: "update",
    value: function update() {
      var _this3 = this;

      var data = this.state.formData;
      var Service = this.service.value;
      if (!Service.count || !data) return;

      for (var i in data) {
        if (data[i] === "None") data[i] = null;
      }

      Service.update(data.id, data).then(function (res) {
        return _this3.serviceUpdate(_this3.state.page).then(function () {
          return _this3.setState({
            showForm: false
          });
        });
      }).catch(function (e) {
        return window.Materialize ? window.Materialize.toast('Can not update!', 5000) : window.M.toast({
          html: 'Can not update!',
          displayLength: 5000
        });
      });
    }
  }, {
    key: "add",
    value: function add() {
      var _this4 = this;

      var data = this.state.formData;
      var Service = this.service.value;
      if (!Service.count || !data) return;
      delete data.id;
      Service.add(data).then(function (res) {
        return _this4.serviceUpdate(_this4.state.page);
      }).then(function () {
        return _this4.setState({
          showForm: false
        });
      }).catch(function (e) {
        return window.Materialize ? window.Materialize.toast('Can not Add!', 5000) : window.M.toast({
          html: 'Can not Add!',
          displayLength: 5000
        });
      });
    }
  }, {
    key: "rowEdit",
    value: function rowEdit(row) {
      var _this5 = this;

      if (!row) return;
      var Service = this.service.value;
      if (Service.update && row.id) Service.update(row.id, row).then(function () {
        return _this5.serviceUpdate(_this5.state.page);
      }).catch(function (e) {
        window.Materialize.toast('Can not Edit!', 5000);

        _this5.forceUpdate();
      });
    }
  }, {
    key: "_rowEdited",
    value: function _rowEdited(row) {
      if (!row) return;
      var headers = this.FormHeaders.value;
      var mod = this.prepareForm(headers, row);
      this.setState({
        showForm: true,
        model: mod,
        mode: 1,
        formButton: 'Edit'
      });
    }
  }, {
    key: "_rowDeleted",
    value: function _rowDeleted(row) {
      var _this6 = this;

      if (!row) return;
      var Service = this.service.value;
      if (Service.delete && row.id) Service.delete(row.id).then(function () {
        return _this6.serviceUpdate(_this6.state.page);
      });
    }
  }, {
    key: "handleClick",
    value: function handleClick() {// console.log("added");
    }
  }, {
    key: "prepareForm",
    value: function prepareForm(headers) {
      var row = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var mod = {}; // console.log(headers);

      for (var i in headers) {
        if (!headers[i]) continue; //if(headers[i].fieldName === "id") continue;

        mod[headers[i].Name || headers[i].fieldName] = {
          type: "text",
          placeholder: i,
          columns: "col s12  l6 xl4",
          value: row[i],
          filter: headers[i].filter
        };
      }

      return mod;
    }
  }, {
    key: "showAddForm",
    value: function showAddForm() {
      var headers = this.FormHeaders.value; // add Required !

      var mod = this.prepareForm(headers);
      this.setState({
        showForm: true,
        model: mod,
        mode: 0,
        formButton: 'Add'
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this7 = this;

      var page = this.state.page,
          totalPages = this.state.totalPages,
          data = this.state.data;

      var TableView = _react.default.createElement(_reactMaterialize.Row, {
        style: {
          display: 'flex'
        },
        key: 'Table'
      }, _react.default.createElement(_reactMaterialize.Col, {
        s: 2,
        style: this.props.filterStyle,
        className: this.props.filterClassName
      }, _react.default.createElement(_FilterModule.default, {
        Inputs: this.FilterInput.value,
        Filters: function Filters(filters) {
          return _this7.setFilters(filters);
        }
      })), _react.default.createElement(_reactMaterialize.Col, {
        s: 10
      }, _react.default.createElement(Table, {
        TableHeaders: this.TableHeaders.value,
        TableData: data,
        TableClass: this.TableClass.value,
        LiveEdit: this.LiveEdit.value,
        EditedRow: function EditedRow(v) {
          return _this7.rowEdit(v);
        },
        onEdit: function onEdit(v) {
          return _this7._rowEdited(v);
        },
        onDelete: function onDelete(v) {
          return _this7._rowDeleted(v);
        }
      }), _react.default.createElement(_reactMaterialize.Row, null, _react.default.createElement(_reactMaterialize.Col, {
        offset: "s10"
      }, _react.default.createElement(_reactMaterialize.Button, {
        onClick: function onClick() {
          return _this7.showAddForm();
        }
      }, "Add"))), _react.default.createElement(Pagination, {
        selected: page,
        lastPage: totalPages,
        onPage: function onPage(v) {
          return _this7.pageChanged(v);
        }
      })));

      var FormView = _react.default.createElement(_reactMaterialize.Row, {
        key: 'Form'
      }, _react.default.createElement(_reactMaterialize.Col, {
        s: 12
      }, _react.default.createElement(Form, {
        FormInputs: this.state.model,
        button: this.state.formButton,
        formData: function formData(_formData) {
          return _this7.setState({
            formData: _formData
          });
        },
        className: 'AdminDataForm'
      }), _react.default.createElement(_reactMaterialize.Button, {
        onClick: function onClick(data) {
          return _this7.state.mode ? _this7.update() : _this7.add();
        }
      }, "Save")));

      return [this.state.showForm ? FormView : TableView, _get(_getPrototypeOf(ListModule.prototype), "render", this).call(this)];
    }
  }]);

  return ListModule;
}(_modularityFront.default.Module);

ListModule.Inputs = {
  service: {
    type: Module.Types.Object,
    defaultValue: {}
  },
  perPage: {
    type: Module.Types.Number,
    defaultValue: 2
  },
  TableHeaders: {
    type: Module.Types.Object,
    defaultValue: {
      "Id": "id",
      "Name": "name",
      "Value": "price"
    }
  },
  FormHeaders: {
    type: Module.Types.Object,
    defaultValue: {
      "Id": "id",
      "Name": "name",
      "Value": "price"
    }
  },
  TableClass: {
    type: Module.Types.Text,
    defaultValue: "striped centered"
  },
  LiveEdit: {
    type: Module.Types.Boolean,
    defaultValue: false
  },
  FilterInput: {
    type: Module.Types.Array,
    arrType: Module.Types.Object
  }
};
ListModule.Outputs = {
  onFilters: {}
};
ListModule.Category = "Nikatlas";
ListModule.EditPosition = "top-right";
var _default = ListModule;
exports.default = _default;