"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

var _index = _interopRequireDefault(require("../Modules/index.js"));

var _FilterModule = _interopRequireDefault(require("../Modules/FilterModule.js"));

require("./TableData.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Table = _index.default.Table,
    Pagination = _index.default.Pagination;
var Module = _modularityFront.default.Module;

var pTimeout = function pTimeout(time, item) {
  return new Promise(function (res, rej) {
    setTimeout(function () {
      return res(item);
    }, time);
  });
};

var TableData =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(TableData, _Modularity$Module);

  function TableData(props) {
    var _this;

    _classCallCheck(this, TableData);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TableData).call(this, props));
    _this.state = {
      page: 1,
      data: [],
      totalPages: 1
    };

    _this.service.onUpdate(function () {
      return _this.serviceUpdate(_this.state.page);
    });

    _this.serviceUpdate(_this.state.page);

    return _this;
  }

  _createClass(TableData, [{
    key: "serviceUpdate",
    value: function serviceUpdate() {
      var _this2 = this;

      var page = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      var Service = this.service.value;
      if (!Service.count) return;
      var perPage = this.perPage.value;
      return Service.count().then(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 1),
            counter = _ref2[0].counter;

        var totalPages = parseInt(counter / perPage + 0.999);
        page = page <= totalPages ? page : totalPages;

        _this2.setState({
          totalPages: totalPages,
          page: page
        });

        return Service.getPage(page, perPage);
      }).then(function (data) {
        _this2.setState({
          data: data
        });
      }).catch(function (e) {
        return console.log(e);
      });
    }
  }, {
    key: "pageChanged",
    value: function pageChanged(v) {
      this.serviceUpdate(v);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var page = this.state.page,
          totalPages = this.state.totalPages,
          data = this.state.data;

      var TableView = _react.default.createElement(_reactMaterialize.Row, {
        style: {
          display: 'flex'
        },
        key: 'Table' + this.getId()
      }, _react.default.createElement(_reactMaterialize.Col, {
        s: 12
      }, _react.default.createElement(Table, {
        TableHeaders: this.TableHeaders.value,
        TableData: data,
        TableClass: this.TableClass.value,
        onView: this.props.onView
      }), _react.default.createElement(Pagination, {
        selected: page,
        lastPage: totalPages,
        onPage: function onPage(v) {
          return _this3.pageChanged(v);
        }
      })));

      return [TableView, _get(_getPrototypeOf(TableData.prototype), "render", this).call(this)];
    }
  }]);

  return TableData;
}(_modularityFront.default.Module);

TableData.Inputs = {
  service: {
    type: Module.Types.Object,
    defaultValue: {}
  },
  perPage: {
    type: Module.Types.Number,
    defaultValue: 10
  },
  TableHeaders: {
    type: Module.Types.Object,
    defaultValue: {
      "Id": "id",
      "Name": "name",
      "Value": "price"
    }
  },
  TableClass: {
    type: Module.Types.Text,
    defaultValue: "striped centered"
  }
};
TableData.Outputs = {};
TableData.Category = "Higher Modules";
TableData.EditPosition = "top-right";
var _default = TableData;
exports.default = _default;