"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

var _DictionaryService = _interopRequireDefault(require("../Services/DictionaryService"));

var _Table = _interopRequireDefault(require("../Modules/Table"));

require("./ViewOrder.css");

var _reactMoment = _interopRequireDefault(require("react-moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var ViewOrder =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(ViewOrder, _Modularity$Module);

  function ViewOrder(props) {
    var _this;

    _classCallCheck(this, ViewOrder);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ViewOrder).call(this, props));
    _this.state = {
      productHeaders: {
        ProductID: "id",
        image: "image",
        Name: "name",
        Quantity: "quantity",
        Price: {
          field: "price",
          suffix: " €"
        }
      }
    };
    console.log(_this.Order.value);
    return _this;
  }

  _createClass(ViewOrder, [{
    key: "render",
    value: function render() {
      var orderInfo = this.Order.value.Addresses;

      var UserInfo = _react.default.createElement(_reactMaterialize.Collection, {
        header: _react.default.createElement("div", {
          className: "order_title"
        }, _react.default.createElement("div", {
          className: "info_item order_dict"
        }, _DictionaryService.default.get("Order")), _react.default.createElement("div", {
          className: "info_item order_status green darken-1"
        }, "Status: ", this.Order.value.status))
      }, _react.default.createElement(_reactMaterialize.CollectionItem, {
        className: "title"
      }, _react.default.createElement("span", {
        className: "sp_title"
      }, "Address"), _react.default.createElement("div", {
        className: "second"
      }, orderInfo.address || "")), _react.default.createElement(_reactMaterialize.CollectionItem, {
        className: "title"
      }, _react.default.createElement("span", {
        className: "sp_title"
      }, "City"), _react.default.createElement("div", {
        className: "second"
      }, orderInfo.city || "")), _react.default.createElement(_reactMaterialize.CollectionItem, {
        className: "title"
      }, _react.default.createElement("span", {
        className: "sp_title"
      }, "State"), _react.default.createElement("div", {
        className: "second"
      }, orderInfo.state || "")), _react.default.createElement(_reactMaterialize.CollectionItem, {
        className: "title"
      }, _react.default.createElement("span", {
        className: "sp_title"
      }, "Postal Code"), _react.default.createElement("div", {
        className: "second"
      }, orderInfo.postalcode || "")), _react.default.createElement(_reactMaterialize.CollectionItem, {
        className: "title"
      }, _react.default.createElement("span", {
        className: "sp_title"
      }, "Phone"), _react.default.createElement("div", {
        className: "second"
      }, orderInfo.phone || "")), _react.default.createElement(_reactMaterialize.CollectionItem, {
        className: "title"
      }, _react.default.createElement("span", {
        className: "sp_title"
      }, "Created"), _react.default.createElement("div", {
        className: "second"
      }, _react.default.createElement(_reactMoment.default, {
        format: "HH:mm DD/MM/YYYY"
      }, this.Order.value.createdAt || ""))));

      return _react.default.createElement(_reactMaterialize.Row, {
        className: "card"
      }, _react.default.createElement(_reactMaterialize.Col, {
        s: 12,
        className: "card-content"
      }, _react.default.createElement(_reactMaterialize.Row, null, _react.default.createElement(_reactMaterialize.Col, {
        className: "",
        s: 4
      }, UserInfo), _react.default.createElement(_reactMaterialize.Col, {
        s: 8
      }, _react.default.createElement(_Table.default, {
        TableData: JSON.parse(this.Order.value.products),
        TableHeaders: this.state.productHeaders
      }))), _react.default.createElement(_reactMaterialize.Row, {
        className: "OrderProducts"
      }), _get(_getPrototypeOf(ViewOrder.prototype), "render", this).call(this)));
    }
  }]);

  return ViewOrder;
}(_modularityFront.default.Module);

ViewOrder.Inputs = {
  Order: {
    type: Module.Types.Object,
    defaultValue: {}
  }
};
ViewOrder.EditPosition = "bottom-right";
ViewOrder.Category = "sxoinas";
var _default = ViewOrder;
exports.default = _default;