"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

require("./Card.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var CardModule =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(CardModule, _Modularity$Module);

  function CardModule(props) {
    _classCallCheck(this, CardModule);

    return _possibleConstructorReturn(this, _getPrototypeOf(CardModule).call(this, props));
  }

  _createClass(CardModule, [{
    key: "addProd",
    value: function addProd(e) {
      e.preventDefault();
      var prod = {
        id: this.props.id,
        name: this.CardTitle.value,
        price: this.Price.value,
        image: this.CardImage.value,
        quantity: 1
      };
      this.product.set(prod);
      e.stopPropagation();
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var CardButton = this.CardButton.value;
      return _react.default.createElement("div", {
        className: "custom_card " + this.props.className
      }, _react.default.createElement(_reactMaterialize.Card, {
        className: "hoverable",
        header: _react.default.createElement(_reactMaterialize.CardTitle, {
          reveal: true,
          className: "card_image cursor",
          onClick: function onClick() {
            return _this.props.onClick && _this.props.onClick();
          },
          image: this.CardImage.value,
          waves: "light"
        }),
        title: this.CardTitle.value,
        reveal: this.CardBody.value,
        actions: [CardButton ? _react.default.createElement("div", {
          key: this.getId(),
          className: "bottom_card"
        }, _react.default.createElement("small", {
          className: "pricenovat"
        }, "\u03C7\u03C9\u03C1\u03AF\u03C2 \u03A6\u03A0\u0391 ", (this.Price.value * 0.76).toFixed(2), " \u20AC"), _react.default.createElement("div", {
          className: "price"
        }, _react.default.createElement("div", null, this.Price.value, " \u20AC")), _react.default.createElement("div", null, _react.default.createElement(_reactMaterialize.Button, {
          onClick: function onClick(e) {
            return _this.addProd(e);
          },
          floating: true,
          small: true,
          className: "red",
          waves: "light",
          icon: "add"
        }))) : _react.default.createElement("label", null, "Price here")]
      }));
    }
  }]);

  return CardModule;
}(_modularityFront.default.Module);

CardModule.Inputs = {
  CardTitle: {
    type: Module.Types.Text
  },
  CardBody: {
    type: Module.Types.Text,
    defaultValue: "I am a very simple card. I am good at containing small bits of information. I am convenient because I require little markup to use effectively."
  },
  CardImage: {
    type: Module.Types.Text
  },
  Price: {
    type: Module.Types.Real,
    defaultValue: null
  },
  CardButton: {
    //should be boolean if we have just add 
    type: Module.Types.Text,
    defaultValue: true
  }
};
CardModule.Outputs = {
  product: {}
};
CardModule.Category = "sxoinas";
var _default = CardModule;
exports.default = _default;