"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var CarouselPanelModule =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(CarouselPanelModule, _Modularity$Module);

  function CarouselPanelModule(props) {
    var _this;

    _classCallCheck(this, CarouselPanelModule);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CarouselPanelModule).call(this, props));
    _this.state = {};
    return _this;
  }

  _createClass(CarouselPanelModule, [{
    key: "render",
    value: function render() {
      var panels = this.CarouselPanel.value.map(function (item) {
        return _react.default.createElement("div", {
          className: item.panelClass
        }, _react.default.createElement("h2", null, item.header), _react.default.createElement("p", {
          className: item.bodyClass
        }, item.body));
      });
      return _react.default.createElement(_reactMaterialize.Row, null, _react.default.createElement(_reactMaterialize.Col, {
        s: 12
      }, _react.default.createElement(_reactMaterialize.Carousel, {
        className: "carousel carousel-slider center",
        fixedItem: _react.default.createElement("div", {
          className: this.CarouselButton.value.position
        }, _react.default.createElement("a", {
          onClick: function onClick(e) {
            return console.log("clicked");
          },
          className: this.CarouselButton.value.style
        }, this.CarouselButton.value.content)),
        options: {
          fullWidth: this.CarouselOptions.value.fullWidth,
          indicators: this.CarouselOptions.value.indicators
        }
      }, panels), _get(_getPrototypeOf(CarouselPanelModule.prototype), "render", this).call(this)));
    }
  }]);

  return CarouselPanelModule;
}(_modularityFront.default.Module);

CarouselPanelModule.Inputs = {
  CarouselTitle: {
    type: Module.Types.Text,
    defaultValue: "Product Title"
  },
  CarouselPanel: {
    type: Module.Types.Array,
    defaultValue: [{
      header: "First Panel",
      body: "this is the first panel",
      panelClass: "red",
      bodyClass: "white-text"
    }, {
      header: "second Panel",
      body: "this is the second panel",
      panelClass: "amber",
      bodyClass: "white-text"
    }, {
      header: "third Panel",
      body: "this is the third panel",
      panelClass: "blue",
      bodyClass: "white-text"
    }],
    arrType: Module.Types.Object
  },
  CarouselOptions: {
    type: Module.Types.Object,
    defaultValue: {
      fullWidth: true,
      indicators: true
    }
  },
  CarouselImages: {
    type: Module.Types.Array,
    defaultValue: ["car1.jpg", "car2.jpg", "car3.jpg", "car4.jpg"],
    arrType: Module.Types.Text
  },
  CarouselButton: {
    type: Module.Types.Object,
    defaultValue: {
      position: "carousel-fixed-item center",
      style: "btn waves-effect white grey-text darken-text-2",
      content: "Click me"
    }
  }
};
CarouselPanelModule.Category = "sxoinas";
var _default = CarouselPanelModule;
exports.default = _default;