"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _Chip = _interopRequireDefault(require("@material-ui/core/Chip"));

require("./chip.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;
var chipTypes = ['manytomany', 'exact', 'onetoone'];

var ChipModule =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(ChipModule, _Modularity$Module);

  function ChipModule(props) {
    _classCallCheck(this, ChipModule);

    return _possibleConstructorReturn(this, _getPrototypeOf(ChipModule).call(this, props));
  }

  _createClass(ChipModule, [{
    key: "removeChip",
    value: function removeChip(filter, key) {
      var values = filter.values || [];

      if (key) {
        var indx = values.indexOf(key);
        indx > -1 && values.splice(indx, 1);
        filter.values = values;
      } else {
        // range specific
        delete filter.values;
        filter.reset && filter.reset();
      }

      this.chips = this.chips.map(function (item) {
        return item.name === filter.name ? filter : item;
      });
      this.Filters.set(this.chips);
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      this.chips = this.Inputs.value || [];
      var chipsView = this.chips.map(function (filter, index) {
        var options = filter.options || {};

        if (chipTypes.includes(filter.type)) {
          return (filter.values || []).map(function (key, index) {
            return _react.default.createElement(_Chip.default, {
              key: key,
              label: options[key],
              className: "custom_chip",
              onDelete: function onDelete() {
                return _this.removeChip(filter, key);
              }
            });
          });
        } else if (filter.type === "range" && filter.values) {
          return _react.default.createElement(_Chip.default, {
            key: "range" + filter.values[0] + filter.values[1],
            label: filter.values[0] + " - " + filter.values[1],
            className: "custom_chip",
            onDelete: function onDelete() {
              return _this.removeChip(filter);
            }
          });
        } else {
          return null;
        }
      });
      return _react.default.createElement("div", null, chipsView);
    }
  }]);

  return ChipModule;
}(_modularityFront.default.Module);

ChipModule.Inputs = {
  Inputs: {
    type: Module.Types.Array,
    arrType: Module.Types.Object
  }
};
ChipModule.Outputs = {
  Filters: {}
};
ChipModule.EditPosition = "center";
ChipModule.Category = "sxoinas";
var _default = ChipModule;
exports.default = _default;