"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactMaterialize = require("react-materialize");

var _modularityFront = _interopRequireDefault(require("modularity-front"));

require("./CustomTable.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var CustomTable =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(CustomTable, _Modularity$Module);

  function CustomTable(props) {
    _classCallCheck(this, CustomTable);

    return _possibleConstructorReturn(this, _getPrototypeOf(CustomTable).call(this, props));
  }

  _createClass(CustomTable, [{
    key: "render",
    value: function render() {
      var headers = this.TableHeader.value.map(function (header) {
        return _react.default.createElement("th", null, header);
      });
      var items = this.TableBody.value;
      var body = Object.keys(items).map(function (key, index) {
        return _react.default.createElement("tr", {
          key: index,
          className: "row_content"
        }, _react.default.createElement("td", null, items[key].name), _react.default.createElement("td", null, items[key].price, " \u20AC"), _react.default.createElement("td", null, items[key].quantity), _react.default.createElement("td", null, (items[key].price * items[key].quantity, 3).toFixed(2), " \u20AC"));
      });
      return _react.default.createElement(_reactMaterialize.Row, null, _react.default.createElement("table", {
        className: "custom_table"
      }, _react.default.createElement("thead", {
        className: "header"
      }, _react.default.createElement("tr", {
        className: "header_content"
      }, headers)), _react.default.createElement("tbody", {
        className: "table_body"
      }, body)), _get(_getPrototypeOf(CustomTable.prototype), "render", this).call(this));
    }
  }]);

  return CustomTable;
}(_modularityFront.default.Module);

CustomTable.EditPosition = "center";
CustomTable.Inputs = {
  TableHeader: {
    type: Module.Types.Array,
    defaultValue: ['Selected Items', 'Unit Price', 'Quantity', 'SubTotal']
  },
  TableBody: {
    type: Module.Types.Object,
    defaultValue: {}
  }
};
CustomTable.Category = 'sxoinas';
var _default = CustomTable;
exports.default = _default;