"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

var _Embed = _interopRequireDefault(require("./UserInputs/Embed"));

require("./Footer.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;
var Link = _modularityFront.default.Modules.Link;

var FooterModule =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(FooterModule, _Modularity$Module);

  function FooterModule(props) {
    var _this;

    _classCallCheck(this, FooterModule);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FooterModule).call(this, props));
    _this.state = {};
    return _this;
  }

  _createClass(FooterModule, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var footLinks = this.FooterLinkHeaders.value.map(function (item, index) {
        return _react.default.createElement("li", {
          key: index
        }, _react.default.createElement(Link, {
          link: _this2.FooterLinks.value[index] || "",
          className: "grey-text text-lighten-3"
        }, item));
      });
      return _react.default.createElement("div", null, _react.default.createElement(_reactMaterialize.Footer, {
        copyrights: _react.default.createElement(_Embed.default, {
          className: "copy",
          html: this.FooterCopyright.value
        }),
        moreLinks: _react.default.createElement(_Embed.default, {
          className: "company",
          html: this.FooterCompany.value
        }),
        links: _react.default.createElement("ul", null, footLinks),
        className: this.FooterStyle.value
      }, _react.default.createElement("h5", {
        className: "white-text"
      }, this.FooterHeader.value), _react.default.createElement("div", {
        className: "grey-text text-lighten-4"
      }, _react.default.createElement(_Embed.default, {
        html: this.FooterContent.value
      }))), _get(_getPrototypeOf(FooterModule.prototype), "render", this).call(this));
    }
  }]);

  return FooterModule;
}(_modularityFront.default.Module);

FooterModule.Inputs = {
  FooterHeader: {
    type: Module.Types.Text,
    defaultValue: "Footer Header"
  },
  FooterLinkHeaders: {
    type: Module.Types.Array,
    defaultValue: ["Home", "There", "Somewhere", "Route"],
    arrType: Module.Types.Text
  },
  FooterLinks: {
    type: Module.Types.Array,
    defaultValue: ["home", "there", "somewhere", "route"],
    arrType: Module.Types.Text
  },
  FooterCopyright: {
    type: Module.Types.Text,
    defaultValue: "&copy 2015 Copyright Text"
  },
  FooterCompany: {
    type: Module.Types.Text,
    defaultValue: "Constructed By Nikos Atlas & Konstantinos Schoinas  "
  },
  FooterContent: {
    type: Module.Types.Text,
    defaultValue: "You can use rows and columns here to organize your footer content."
  },
  FooterStyle: {
    type: Module.Types.Text,
    defaultValue: "blue-grey darken-1"
  }
};
FooterModule.EditPosition = "bottom-right";
FooterModule.Category = "sxoinas";
var _default = FooterModule;
exports.default = _default;