"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

var _reactExcelRenderer = require("react-excel-renderer");

var _CrudService = _interopRequireDefault(require("../Services/CrudService"));

var _DictionaryService = _interopRequireDefault(require("../Services/DictionaryService"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toArray(arr) { return _arrayWithHoles(arr) || _iterableToArray(arr) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var ImportModule =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(ImportModule, _Modularity$Module);

  function ImportModule(props) {
    var _this;

    _classCallCheck(this, ImportModule);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ImportModule).call(this, props));
    _this.state = {
      rows: [],
      cols: [] // add token

    };
    var propertiesService = {
      Table: _this.Table.value,
      Token: _this.Token.value,
      Service: function Service(service) {
        return _this.updateService(service);
      }
    };
    _this.back_service = new _CrudService.default(propertiesService);
    return _this;
  }

  _createClass(ImportModule, [{
    key: "updateService",
    value: function updateService(s) {
      this.service = s;
    }
  }, {
    key: "sendData",
    value: function sendData() {
      var data = {
        rows: this.state.rows || [],
        cols: this.state.cols || []
      };
      this.service.import(data).then(function (v) {
        console.log(v);
      }).catch(function (e) {
        return console.log(e);
      });
    }
  }, {
    key: "fileHandler",
    value: function fileHandler(event) {
      var _this2 = this;

      var fileObj = event.target.files[0];
      if (!fileObj) return; //just pass the fileObj as parameter

      (0, _reactExcelRenderer.ExcelRenderer)(fileObj, function (err, resp) {
        if (err) {
          console.log(err);
        } else {
          var _resp$rows = _toArray(resp.rows),
              cols = _resp$rows[0],
              data = _resp$rows.slice(1);

          cols = cols.map(function (name, key) {
            return {
              name: name,
              key: key
            };
          });
          console.log(cols);
          console.log(data);

          _this2.setState({
            cols: cols,
            rows: data,
            results: true
          });
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      return _react.default.createElement("div", null, _react.default.createElement("input", {
        type: "file",
        onChange: this.fileHandler.bind(this),
        style: {
          "padding": "10px"
        }
      }), this.state.results === true ? _react.default.createElement("div", null, _react.default.createElement("button", {
        onClick: function onClick() {
          return _this3.sendData();
        }
      }, _DictionaryService.default.get("Import")), _react.default.createElement(_reactExcelRenderer.OutTable, {
        data: this.state.rows,
        columns: this.state.cols,
        tableClassName: "ExcelTable2007",
        tableHeaderRowClass: "heading"
      })) : null, _get(_getPrototypeOf(ImportModule.prototype), "render", this).call(this));
    }
  }]);

  return ImportModule;
}(_modularityFront.default.Module);

ImportModule.EditPosition = "center";
ImportModule.Inputs = {
  Table: {
    type: _modularityFront.default.Module.Types.Text,
    defaultValue: "products"
  },
  Token: {
    type: Module.Types.Text,
    defaultValue: "123123"
  }
};
ImportModule.Outputs = {};
ImportModule.Category = "Nikatlas";
var _default = ImportModule;
exports.default = _default;