"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

var _reactImageGallery = _interopRequireDefault(require("react-image-gallery"));

var _Embed = _interopRequireDefault(require("../UserInputs/Embed"));

var _Toast = _interopRequireDefault(require("../../helpers/Toast"));

var _DictionaryService = _interopRequireDefault(require("../../Services/DictionaryService"));

require("react-image-gallery/styles/css/image-gallery.css");

require("./Present.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var Present =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(Present, _Modularity$Module);

  function Present(props) {
    var _this;

    _classCallCheck(this, Present);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Present).call(this, props));
    _this.state = {
      quantity: 1
    };
    return _this;
  }

  _createClass(Present, [{
    key: "add",
    value: function add() {
      this.addToCart.set(this.state.quantity);

      _Toast.default.success('Added ' + this.state.quantity + ' ' + this.Product.value.name + ' to your cart');
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var product = this.Product.value;
      return _react.default.createElement("div", {
        className: this.props.ClassName
      }, _react.default.createElement("div", {
        className: "ProductContainer"
      }, _react.default.createElement("div", {
        className: "ProductTop row"
      }, _react.default.createElement("div", {
        className: "ProductImage col s12 m4 l3"
      }, _react.default.createElement(_reactImageGallery.default, {
        items: (product.images || [product.image]).map(function (img) {
          return {
            original: img,
            thumbnail: img
          };
        }),
        showPlayButton: false
      })), _react.default.createElement("div", {
        className: "col s12 m8 l9 ProductShop"
      }, _react.default.createElement("div", {
        className: "row"
      }, _react.default.createElement("div", {
        className: "col s12 l8 ProductName"
      }, _react.default.createElement("h5", {
        style: {
          paddingBottom: 10
        }
      }, product.name), _react.default.createElement(_Embed.default, {
        html: product.shortdescription
      }), product.reference && _react.default.createElement("p", null, _react.default.createElement("b", null, _DictionaryService.default.get("Reference")), " - ", product.reference), product.ean13 && _react.default.createElement("p", null, "EAN 13: ", product.ean13)), !this.props.noBuy && _react.default.createElement("div", {
        className: "card col s12 l4 center ProductPrice"
      }, _react.default.createElement("h5", null, _react.default.createElement("div", null, (product.price || 0).toFixed(2), " \u20AC"), _react.default.createElement("small", null, "\u03C7\u03C9\u03C1\u03AF\u03C2 \u03A6\u03A0\u0391 ", (product.price * 0.76).toFixed(2))), _react.default.createElement("div", null, _react.default.createElement("span", null, _DictionaryService.default.get("Quantity")), _react.default.createElement("div", {
        className: "ProductQuantity"
      }, _react.default.createElement(_reactMaterialize.Button, {
        flat: true,
        onClick: function onClick() {
          return _this2.setState({
            quantity: _this2.state.quantity - 1 || 1
          });
        }
      }, "-"), _react.default.createElement("span", {
        style: {
          padding: 10
        }
      }, this.state.quantity), _react.default.createElement(_reactMaterialize.Button, {
        flat: true,
        onClick: function onClick() {
          return _this2.setState({
            quantity: _this2.state.quantity + 1 <= product.quantity ? _this2.state.quantity + 1 : _this2.state.quantity
          });
        }
      }, "+")), _react.default.createElement("small", null, _DictionaryService.default.get("Available"), " ", product.quantity)), _react.default.createElement("br", null), product.quantity > 0 && _react.default.createElement(_reactMaterialize.Button, {
        onClick: function onClick() {
          return _this2.add();
        }
      }, _DictionaryService.default.get("Add to Cart")))))), _react.default.createElement("div", {
        className: "ProductContent"
      }, _react.default.createElement("h5", null, _DictionaryService.default.get("Description")), _react.default.createElement(_Embed.default, {
        html: product.description
      }))), _get(_getPrototypeOf(Present.prototype), "render", this).call(this));
    }
  }]);

  return Present;
}(_modularityFront.default.Module);

Present.EditPosition = "center";
Present.Inputs = {
  Product: {
    type: Module.Types.Object,
    defaultValue: {
      name: "Test product Name",
      description: "Test description",
      price: 12.34,
      images: ["/car1.jpg", "/car2.jpg", "/car3.jpg"]
    }
  },
  ClassName: {
    type: Module.Types.Text
  }
};
Present.Outputs = {
  addToCart: {}
};
Present.Category = "Nikatlas";
var _default = Present;
exports.default = _default;