"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;
var Link = _modularityFront.default.Modules.Link;

var SideNavModule =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(SideNavModule, _Modularity$Module);

  function SideNavModule(props) {
    var _this;

    _classCallCheck(this, SideNavModule);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SideNavModule).call(this, props));
    _this.state = {};
    return _this;
  }

  _createClass(SideNavModule, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var NavItems = this.SideNavItems.value.map(function (item, index) {
        return _react.default.createElement(_reactMaterialize.SideNavItem, {
          key: index,
          userView: item.userView || false,
          user: item.user || {},
          divider: item.divider || false,
          subheader: item.subheader || false,
          waves: item.waves || false,
          href: item.link,
          onClick: function onClick(e) {
            if (item.link) _this2.CoreSystem.go(item.link);
            e.preventDefault();
          }
        }, item.content || "");
      });
      return _react.default.createElement(_reactMaterialize.SideNav, {
        trigger: this.props.trigger || _react.default.createElement(_reactMaterialize.Button, null, _react.default.createElement("i", {
          className: this.NavButton.value
        })),
        options: this.Options.value
      }, NavItems, _get(_getPrototypeOf(SideNavModule.prototype), "render", this).call(this));
    }
  }]);

  return SideNavModule;
}(_modularityFront.default.Module);

SideNavModule.Inputs = {
  SideNavItems: {
    type: Module.Types.Array,
    defaultValue: [{
      userView: true,
      content: "",
      link: "#",
      user: {
        background: 'card.jpg',
        name: 'John Doe',
        image: 'yuna.jpg',
        email: 'jdandturk@gmail.com'
      }
    }, {
      divider: true
    }, {
      content: "SOme content",
      link: "some",
      subheader: true
    }, {
      content: "Second Content",
      link: "some"
    }],
    arrType: Module.Types.Object
  },
  Options: {
    type: Module.Types.Object,
    defaultValue: {
      closeOnClick: true
    }
  },
  NavButton: {
    type: Module.Types.Text,
    defaultValue: "fa fa-bars"
  }
};
SideNavModule.Category = "sxoinas";
var _default = SideNavModule;
exports.default = _default;