"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactMaterialize = require("react-materialize");

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _Menu = _interopRequireDefault(require("@material-ui/core/Menu"));

var _core = require("@material-ui/core/");

var _styles = require("@material-ui/core/styles");

require("./Filter.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var DropDownFilter =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(DropDownFilter, _Modularity$Module);

  function DropDownFilter(props) {
    var _this;

    _classCallCheck(this, DropDownFilter);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DropDownFilter).call(this, props));
    _this.state = _objectSpread({}, props.filter, {
      value: _this.getFilterValue() || props.filter.value || ''
    });
    return _this;
  }

  _createClass(DropDownFilter, [{
    key: "getFilterValue",
    value: function getFilterValue() {
      var options = this.filter.value.options;
      var array = Object.keys(options || {});

      for (var key in array) {
        if (options[array[key]] === this.props.defaultValue) {
          return array[key];
        }
      }

      return false;
    }
  }, {
    key: "checkFilter",
    value: function checkFilter(e) {
      var values = [e.target.value];
      this.setState({
        value: e.target.value
      });
      this.Filters.set(_objectSpread({}, this.state, {
        values: values
      }));
      console.log("sss", this.Filters);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var options;

      if (this.filter.value.length) {
        // if array make labels and values same
        var array = this.filter.value.options;
        options = array.map(function (option, index) {
          return _react.default.createElement(_core.MenuItem, {
            value: option,
            key: index
          }, option);
        });
      } else {
        // if json make values the keys of json and labels the values of json
        var _array = Object.keys(this.filter.value.options || {});

        options = _array.map(function (key, index) {
          return _react.default.createElement(_core.MenuItem, {
            value: key,
            key: index
          }, _this2.filter.value.options[key]);
        });
      }

      return _react.default.createElement("div", {
        className: "flex-item"
      }, _react.default.createElement(_core.FormControl, {
        style: {
          minWidth: 120,
          width: "100%",
          marginBottom: 8
        }
      }, _react.default.createElement(_core.InputLabel, null, this.filter.value.name), _react.default.createElement(_core.Select, {
        value: this.state.value,
        onChange: function onChange(e) {
          return _this2.checkFilter(e);
        }
      }, !this.filter.value.required && _react.default.createElement(_core.MenuItem, {
        value: "None"
      }, "None"), options)));
    }
  }]);

  return DropDownFilter;
}(_modularityFront.default.Module);

DropDownFilter.Inputs = {
  filter: {
    type: Module.Types.Object
  }
};
DropDownFilter.Outputs = {
  Filters: {}
};
DropDownFilter.Category = 'sxoinas';
var _default = DropDownFilter;
exports.default = _default;