"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactMaterialize = require("react-materialize");

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _Checkbox = _interopRequireDefault(require("@material-ui/core/Checkbox"));

var _FormControlLabel = _interopRequireDefault(require("@material-ui/core/FormControlLabel"));

require("./Filter.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var ExactFilter =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(ExactFilter, _Modularity$Module);

  function ExactFilter(props) {
    _classCallCheck(this, ExactFilter);

    return _possibleConstructorReturn(this, _getPrototypeOf(ExactFilter).call(this, props));
  }

  _createClass(ExactFilter, [{
    key: "checkFilter",
    value: function checkFilter(value) {
      var values = this.filter.value.values || [];
      var indx = values.indexOf(value);
      indx > -1 ? values.splice(indx, 1) : values.push(value);
      this.Filters.set(_objectSpread({}, this.filter.value, {
        values: values
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var horizontal = this.horizontal.value;
      var Filter = this.filter.value;
      var options;

      if (Filter.options) {
        // if json make values the keys of json and labels the values of json
        var array = Object.keys(Filter.options || {});
        options = array.map(function (key, index) {
          return _react.default.createElement(Option, {
            value: key,
            label: Filter.options[key],
            checked: (Filter.values || []).includes(key),
            onChange: function onChange(v) {
              return _this.checkFilter(v);
            },
            key: index
          });
        });
      }

      return horizontal ? _react.default.createElement("div", {
        className: "flex-item exact"
      }, _react.default.createElement("div", {
        className: "exact-header"
      }, Filter.name), _react.default.createElement("div", {
        className: "exact-content"
      }, options)) : _react.default.createElement("div", {
        className: "flex-item exact"
      }, _react.default.createElement(_reactMaterialize.Row, {
        style: {
          paddingBottom: 8
        }
      }, _react.default.createElement(_reactMaterialize.Col, null, Filter.name)), _react.default.createElement("div", null, options));
    }
  }]);

  return ExactFilter;
}(_modularityFront.default.Module);

ExactFilter.Inputs = {
  filter: {
    type: Module.Types.Object
  },
  horizontal: {
    type: Module.Types.Boolean,
    defaultValue: false
  }
};
ExactFilter.Outputs = {
  Filters: {}
};
ExactFilter.Category = 'sxoinas';

var Option =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Option, _React$Component);

  function Option(props) {
    var _this2;

    _classCallCheck(this, Option);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(Option).call(this, props));
    _this2.state = {
      checked: false
    };
    return _this2;
  }

  _createClass(Option, [{
    key: "oncheck",
    value: function oncheck(e) {
      this.props.onChange(this.props.value);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      return _react.default.createElement("div", null, _react.default.createElement(_FormControlLabel.default, {
        control: _react.default.createElement(_Checkbox.default, {
          color: "primary",
          checked: this.props.checked,
          onChange: function onChange(e) {
            return _this3.oncheck(e);
          },
          value: this.props.value
        }),
        label: this.props.label
      }));
    }
  }]);

  return Option;
}(_react.default.Component);

var _default = ExactFilter;
exports.default = _default;