"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

var _reactSidenav = _interopRequireWildcard(require("@trendmicro/react-sidenav"));

require("./VerticalNavbar.css");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;
var Link = _modularityFront.default.Modules.Link;

var VerticalNavbar =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(VerticalNavbar, _Modularity$Module);

  function VerticalNavbar(props) {
    var _this;

    _classCallCheck(this, VerticalNavbar);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(VerticalNavbar).call(this, props));
    _this.state = {};
    return _this;
  }

  _createClass(VerticalNavbar, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var selectedNavItem = "home";
      var url = this.RoutingSystem.getRoute().url;
      var navitems = this.NavItems.value.map(function (item, indx) {
        if (url.includes(item.link)) {
          selectedNavItem = item.link;
        }

        return _react.default.createElement(_reactSidenav.NavItem, {
          key: item.text + item.link,
          eventKey: item.link
        }, _react.default.createElement(_reactSidenav.NavIcon, null, _react.default.createElement("i", {
          className: "fa fa-fw " + item.icon,
          style: {
            fontSize: '1.75em'
          }
        })), _react.default.createElement(_reactSidenav.NavText, null, item.text));
      });
      return _react.default.createElement(_reactSidenav.default, {
        onSelect: function onSelect(eventKey, event) {
          _this2.CoreSystem.go(eventKey);
        },
        defaultExpanded: this.Expanded.value
      }, _react.default.createElement(_reactSidenav.default.Nav, {
        selected: selectedNavItem
      }, navitems), _get(_getPrototypeOf(VerticalNavbar.prototype), "render", this).call(this, false));
    }
  }]);

  return VerticalNavbar;
}(_modularityFront.default.Module);

VerticalNavbar.Inputs = {
  Expanded: {
    type: Module.Types.Boolean,
    defaultValue: true
  },
  NavItems: {
    type: Module.Types.Array,
    defaultValue: [{
      link: "home",
      text: "Home",
      icon: "fa-home"
    }, {
      link: "products",
      text: "Products",
      icon: "fa-product"
    }, {
      link: "products",
      text: "Products",
      icon: "fa-product"
    }],
    arrType: Module.Types.Object
  }
};
VerticalNavbar.Category = "sxoinas";
VerticalNavbar.EditPosition = "center";
var _default = VerticalNavbar;
exports.default = _default;