"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var ViewModule =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(ViewModule, _Modularity$Module);

  function ViewModule(props) {
    var _this;

    _classCallCheck(this, ViewModule);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ViewModule).call(this, props));
    _this.state = {
      routes: _this.Routes.value || {},
      keys: function () {
        var keys = Object.keys(_this.Routes.value || {});
        keys.sort(function (a, b) {
          return b.length - a.length;
        });
        return keys;
      }()
    };

    _this.Routes.onUpdate(function (routes) {
      var keys = Object.keys(routes);
      keys.sort(function (a, b) {
        return b.length - a.length;
      });

      _this.setState({
        routes: routes,
        keys: keys
      });
    });

    var route = _this.RoutingSystem.getRoute();

    console.log(route.url);
    return _this;
  }

  _createClass(ViewModule, [{
    key: "onChildAdd",
    value: function onChildAdd(modid) {
      var route = this.RoutingSystem.getRoute();
      var url = window.prompt("View URL ", route.url);
      var routes = this.Routes.value || {};
      routes[url] = routes[url] ? [].concat(_toConsumableArray(routes[url]), [modid]) : [modid];
      this.Routes.update(routes);
    }
  }, {
    key: "getMatchingMods",
    value: function getMatchingMods() {
      var route = this.RoutingSystem.getRoute();
      var url = route.url;
      var keys = this.state.keys;

      for (var i = 0; i < keys.length; i++) {
        if (url.startsWith(keys[i])) {
          return this.state.routes[keys[i]];
        }
      } // console.log("Routes ", keys);


      return this.state.routes[route.url];
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var subview = this.getMatchingMods() || [];
      return _react.default.createElement("div", null, subview.map(function (id) {
        return _this2.ModuleSystem.modules[id];
      }), _get(_getPrototypeOf(ViewModule.prototype), "render", this).call(this, false));
    }
  }]);

  return ViewModule;
}(_modularityFront.default.Module);

ViewModule.Inputs = {
  Routes: {
    type: Module.Types.Object,
    defaultValue: {}
  }
};
ViewModule.Category = "Nikatlas";
ViewModule.EditPosition = "top-right";
var _default = ViewModule;
exports.default = _default;