"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

var _ListModule = _interopRequireDefault(require("../HigherModules/ListModule.js"));

var _CrudService = _interopRequireDefault(require("../Services/CrudService.js"));

require("./CrudListPackage.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var CrudListPackage =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(CrudListPackage, _Modularity$Module);

  function CrudListPackage(props) {
    var _this;

    _classCallCheck(this, CrudListPackage);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CrudListPackage).call(this, props));
    _this.state = {
      service: null
    };
    _this.headers = _this.TableHeaders.value;
    var table = _this.TableName.value;

    if (_this.RouterDependable.value) {
      // Search route for table
      var route = _this.RoutingSystem.getRoute();

      var regex = /\/[A-Za-z]+\/?/g;
      var found = route.url.match(regex);

      if (found.length) {
        table = found[0].replace('/', '');
      }
    }

    var propertiesService = {
      Table: table,
      Token: _this.Token.value,
      Service: function Service(service) {
        return _this.updateService(service);
      }
    };
    _this.back_service = new _CrudService.default(propertiesService);

    _this.TableName.onUpdate(function (v) {
      _this.back_service.Table.update(v);

      _this.forceUpdate();
    });

    _this.Token.onUpdate(function (v) {
      _this.back_service.Token.update(v);

      _this.forceUpdate();
    });

    return _this;
  }

  _createClass(CrudListPackage, [{
    key: "updateService",
    value: function updateService(service) {
      if (service) this.calculateHeaders(service);
    }
  }, {
    key: "setFilters",
    value: function setFilters(filters) {
      if (filters) {
        this.back_service.Filters.update(filters);
      }

      this.filters = filters;
      this.forceUpdate();
    }
  }, {
    key: "buildFilters",
    value: function buildFilters(headers) {
      var filters = [];

      for (var i in headers) {
        if (headers[i].filter) {
          filters.push(headers[i].filter);
        }
      }

      return filters;
    }
  }, {
    key: "calculateHeaders",
    value: function calculateHeaders(service, test) {
      var _this2 = this;

      service.model().then(function (model) {
        var headers = {};
        var formHeaders = {};

        for (var name in model) {
          if (model[name].disabled) continue;
          var f = {
            Name: model[name].Name,
            type: model[name].type,
            required: !model[name].nullable,
            fieldName: name,
            filter: model[name].Filter
          };
          if (!name.includes("_id") && !(model[name].Filter && model[name].Filter.type === "editor" || model[name].type === "timestamp")) headers[model[name].Name || name] = f;
          formHeaders[model[name].Name || name] = f;
        }

        _this2.formHeaders = formHeaders;
        _this2.headers = headers;
        return headers;
      }).then(function (headers) {
        if (!_this2.filters) _this2.filters = _this2.buildFilters(headers);

        _this2.forceUpdate();
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var service = this.back_service.Service.value;
      return _react.default.createElement("div", null, _react.default.createElement(_ListModule.default, {
        TableHeaders: this.headers,
        TableClass: "striped centered",
        LiveEdit: this.LiveEdit.value,
        FormHeaders: this.formHeaders,
        perPage: this.perPage.value,
        service: service,
        filterStyle: {},
        filterClassName: "grey lighten-5",
        FilterInput: this.filters,
        onFilters: function onFilters(filters) {
          return _this3.setFilters(filters);
        }
      }), _get(_getPrototypeOf(CrudListPackage.prototype), "render", this).call(this));
    }
  }]);

  return CrudListPackage;
}(_modularityFront.default.Module);

CrudListPackage.Inputs = {
  RouterDependable: {
    type: Module.Types.Boolean,
    defaultValue: false
  },
  TableName: {
    type: Module.Types.Text,
    defaultValue: "products"
  },
  perPage: {
    type: Module.Types.Number,
    defaultValue: 2
  },
  TableHeaders: {
    type: Module.Types.Object,
    defaultValue: {
      "Id": "id",
      "Name": "name",
      "Value": "price"
    }
  },
  LiveEdit: {
    type: Module.Types.Boolean,
    defaultValue: false
  },
  Token: {
    type: Module.Types.Text,
    defaultValue: '123123'
  }
};
CrudListPackage.Outputs = {};
CrudListPackage.Category = "NikatlasPackages";
CrudListPackage.EditPosition = "center";
var _default = CrudListPackage;
exports.default = _default;