"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Form = _interopRequireDefault(require("../Modules/Form.js"));

var _Repository = _interopRequireDefault(require("../Services/Repository.js"));

var _FilterModule = _interopRequireDefault(require("../Modules/FilterModule"));

require("./FiltersPackage.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var FiltersPackage =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(FiltersPackage, _Modularity$Module);

  function FiltersPackage(props) {
    var _this;

    _classCallCheck(this, FiltersPackage);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FiltersPackage).call(this, props));
    _this.state = {
      model: []
    };
    var propertiesService = {
      Token: function Token(t) {
        _this.Token.set(t);

        _this.forceUpdate();
      }
    };

    _this.Table.onUpdate(function () {
      return _this.updateRepo();
    });

    if (_this.Table.value) _this.updateRepo();
    return _this;
  }

  _createClass(FiltersPackage, [{
    key: "updateRepo",
    value: function updateRepo() {
      var _this2 = this;

      this.productsRepo = new _Repository.default(this.Table.value);
      this.Repository.set(this.productsRepo);
      this.productsRepo.model().then(function (model) {
        var res = [];

        for (var key in model) {
          model[key].Filter && res.push(model[key].Filter);
        }

        return res;
      }).then(function (model) {
        return _this2.setState({
          model: model
        });
      });
    }
  }, {
    key: "setFilters",
    value: function setFilters(f) {
      if (!f) return;
      this.productsRepo.setFilters(f);
      this.Repository.set(this.productsRepo);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      return _react.default.createElement("div", null, "Filter", _react.default.createElement(_FilterModule.default, {
        Inputs: this.state.model,
        Filters: function Filters(f) {
          return _this3.setFilters(f);
        }
      }), _get(_getPrototypeOf(FiltersPackage.prototype), "render", this).call(this));
    }
  }]);

  return FiltersPackage;
}(_modularityFront.default.Module);

FiltersPackage.Inputs = {
  Table: {
    type: _modularityFront.default.Module.Types.Text
  }
};
FiltersPackage.Outputs = {
  Token: {},
  Repository: {}
};
FiltersPackage.Category = "NikatlasPackages";
FiltersPackage.EditPosition = "top-center";
var _default = FiltersPackage;
exports.default = _default;