"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

var _Pagination = _interopRequireDefault(require("../../Modules/Pagination"));

var _Card = _interopRequireDefault(require("../../Modules/Card"));

var _Repository = _interopRequireDefault(require("../../Services/Repository"));

var _FilterModule = _interopRequireDefault(require("../../Modules/FilterModule"));

var _Present = _interopRequireDefault(require("../../Modules/Product/Present"));

var _Done = _interopRequireDefault(require("@material-ui/icons/Done"));

var _searchbar = _interopRequireDefault(require("../../Modules/searchbar"));

var _Chip = _interopRequireDefault(require("../../Modules/Chip"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var ProductPresentPackage =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(ProductPresentPackage, _Modularity$Module);

  function ProductPresentPackage(props) {
    var _this;

    _classCallCheck(this, ProductPresentPackage);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ProductPresentPackage).call(this, props));
    _this.state = {
      product: {}
    };
    _this.repo = new _Repository.default('products');

    _this.RoutingSystem.onRouteChange("ProductPresentPackage", function () {
      _this.reload();
    }, 'product\/[0-9]+');

    _this.reload();

    return _this;
  }

  _createClass(ProductPresentPackage, [{
    key: "reload",
    value: function reload() {
      var _this2 = this;

      this.productId = this.RoutingSystem.getRoute().params.productId;
      if (!this.productId) return;
      this.repo.get(this.productId).then(function (product) {
        return _this2.setState({
          product: product
        });
      }).catch(function (e) {
        return alert("NOT FOUND");
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      return _react.default.createElement("div", {
        className: "ProductPresentPackage"
      }, _react.default.createElement("div", null, _react.default.createElement(_Present.default, {
        Product: _objectSpread({}, this.state.product, {
          image: this.state.product.image || "/logo.png"
        }),
        addToCart: function addToCart(q) {
          return _this3.AddToCart.set({
            id: _this3.state.product.id,
            name: _this3.state.product.name,
            price: _this3.state.product.price,
            quantity: q
          });
        }
      })), _get(_getPrototypeOf(ProductPresentPackage.prototype), "render", this).call(this));
    }
  }]);

  return ProductPresentPackage;
}(_modularityFront.default.Module);

ProductPresentPackage.EditPosition = "center";
ProductPresentPackage.Inputs = {};
ProductPresentPackage.Outputs = {
  AddToCart: {}
};
ProductPresentPackage.Category = "NikatlasPackages";
var _default = ProductPresentPackage;
exports.default = _default;