"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

var _searchbar = _interopRequireDefault(require("../../Modules/searchbar.js"));

var _API = _interopRequireDefault(require("../../Services/API.js"));

require("./SearchBarPackage.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var SearchBarPackage =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(SearchBarPackage, _Modularity$Module);

  function SearchBarPackage(props) {
    var _this;

    _classCallCheck(this, SearchBarPackage);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SearchBarPackage).call(this, props));
    _this.state = {
      suggestions: {},
      printerSuggestions: {},
      text: ''
    };
    _this.api = new _API.default(); // this.Token.onUpdate((v) => { this.back_service.Token.update(v);this.forceUpdate(); });

    return _this;
  }

  _createClass(SearchBarPackage, [{
    key: "getSuggestions",
    value: function getSuggestions(value) {
      var _this2 = this;

      if (!value || value.length !== 3) return;
      this.api.get('/products/search/' + value).then(function (suggestions) {
        return suggestions;
      }).then(function (suggestions) {
        return suggestions.reduce(function (res, s) {
          res[s.name] = {
            image: s.image,
            key: s.name,
            id: s.id
          };
          return res;
        }, {});
      }).then(function (suggestions) {
        return _this2.setState({
          suggestions: suggestions,
          text: value
        });
      });
      this.api.get('/printers/search/' + value).then(function (suggestions) {
        return suggestions.reduce(function (res, s) {
          res[s.name] = {
            image: s.image,
            key: s.name,
            id: s.id,
            printer: true
          };
          return res;
        }, {});
      }).then(function (printerSuggestions) {
        _this2.setState({
          printerSuggestions: printerSuggestions,
          text: value
        });
      });
    }
  }, {
    key: "search",
    value: function search(data) {
      console.log("SEARCH", data);
      if (data && data.printer) this.CoreSystem.go("/printer/" + data.id);else if (data) this.CoreSystem.go("/search/" + data.key);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      console.log("Suggestions:", this.state.suggestions);
      return _react.default.createElement("div", null, _react.default.createElement(_searchbar.default, {
        Data: _objectSpread({}, this.state.printerSuggestions, this.state.suggestions),
        SearchBar: {
          placeholder: "Search"
        },
        Text: function Text(v) {
          return _this3.getSuggestions(v);
        },
        ObjectData: function ObjectData(data) {
          return _this3.search(data);
        },
        className: "SearchBarPackage " + this.ClassName.value
      }), _get(_getPrototypeOf(SearchBarPackage.prototype), "render", this).call(this));
    }
  }]);

  return SearchBarPackage;
}(_modularityFront.default.Module);

SearchBarPackage.Inputs = {
  SearchRoute: {
    type: Module.Types.Text,
    defaultValue: '/search'
  },
  ClassName: {
    type: Module.Types.Text,
    defaultValue: ''
  }
};
SearchBarPackage.Category = "NikatlasPackages";
SearchBarPackage.EditPosition = "top-center";
var _default = SearchBarPackage;
exports.default = _default;