"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _modularityFront = _interopRequireDefault(require("modularity-front"));

var _reactMaterialize = require("react-materialize");

var _VerticalNavbar = _interopRequireDefault(require("../Modules/VerticalNavbar.js"));

var _LoadedModulesService = _interopRequireDefault(require("../Services/LoadedModulesService.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Module = _modularityFront.default.Module;

var VerticalNavbarPackage =
/*#__PURE__*/
function (_Modularity$Module) {
  _inherits(VerticalNavbarPackage, _Modularity$Module);

  function VerticalNavbarPackage(props) {
    var _this;

    _classCallCheck(this, VerticalNavbarPackage);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(VerticalNavbarPackage).call(this, props));
    _this.state = {
      modules: _this.NavItems.value,
      APIModules: []
    };
    var propertiesService = {
      APIURL: 'CrudModules',
      Modules: function Modules(modules) {
        return _this.setState({
          APIModules: modules || []
        });
      }
    };

    _this.NavItems.onUpdate(function (modules) {
      return _this.setState({
        modules: modules
      });
    });

    _this.back_service = new _LoadedModulesService.default(propertiesService);
    return _this;
  }

  _createClass(VerticalNavbarPackage, [{
    key: "render",
    value: function render() {
      var allmods = [].concat(_toConsumableArray(this.state.modules), _toConsumableArray(this.state.APIModules));
      return [_react.default.createElement(_VerticalNavbar.default, {
        key: Math.random(),
        NavItems: allmods
      }), _get(_getPrototypeOf(VerticalNavbarPackage.prototype), "render", this).call(this)];
    }
  }]);

  return VerticalNavbarPackage;
}(_modularityFront.default.Module);

VerticalNavbarPackage.Inputs = {
  Expanded: {
    type: Module.Types.Boolean,
    defaultValue: true
  },
  NavItems: {
    type: Module.Types.Array,
    defaultValue: [{
      link: "home",
      text: "Home",
      icon: "fa-home"
    }],
    arrType: Module.Types.Object
  }
};
VerticalNavbarPackage.Outputs = {};
VerticalNavbarPackage.Category = "NikatlasPackages";
VerticalNavbarPackage.EditPosition = "center";
var _default = VerticalNavbarPackage;
exports.default = _default;