import React from 'react';
import LinkManager from 'modularity-front';
import Modularity from 'modularity-front';
import {Button ,Col,Row, Input} from 'react-materialize';
import Pagination from '../../Modules/Pagination';
import Card from '../../Modules/Card';
import Repository from '../../Services/Repository';
import FilterModule from '../../Modules/FilterModule';
import ProductPresent from '../../Modules/Product/Present';

import DoneIcon from '@material-ui/icons/Done';
import SearchBar from '../../Modules/searchbar';
import ChipModule from '../../Modules/Chip';

let Module = Modularity.Module;



class ProductPresentPackage extends Modularity.Module {
	constructor(props) {
		super(props);
		this.state = {
			product: {}
		}
		this.repo = new Repository('products');
		
		this.RoutingSystem.onRouteChange("ProductPresentPackage", () => {
			this.reload();
		}, 'product\/[0-9]+');
		this.reload();
	}

	reload() {
		this.productId = this.RoutingSystem.getRoute().params.productId;
		if(!this.productId) return;
		this.repo.get(this.productId)
		.then((product) => this.setState({product}))
		.catch((e) => alert("NOT FOUND"));
	}

	render() {
		return(
			<div className="ProductPresentPackage">
				<div>
					<ProductPresent Product={{...this.state.product, image: this.state.product.image || "/logo.png"}} addToCart={(q) => this.AddToCart.set({
						id: this.state.product.id,
						name: this.state.product.name,
						price: this.state.product.price,
						quantity: q
					}) }/>
				</div>
				{super.render()}
			</div>
		);
				    
	}
}


ProductPresentPackage.EditPosition = "center";
ProductPresentPackage.Inputs = {
}



ProductPresentPackage.Outputs = {
	AddToCart: {}
}

ProductPresentPackage.Category = "NikatlasPackages";
export default ProductPresentPackage;